const { invoke } = window.__TAURI__.tauri;
const { listen } = window.__TAURI__.event;
const { ask } = window.__TAURI__.dialog;
const downBar = document.querySelector(".progressFinished");
//import { listen } from '@tauri-apps/api';

var selected_pack = "";

const download_progress = listen("download_progress", (progress) => {
  console.log("Downloading");
  //console.log("Downloaded "+progress.payload.downloaded/(1024*1024) +"MB / " + progress.payload.total/(1024*1024) + "MB");
  let downProgress = (progress.payload.downloaded/(1024*1024)).toFixed(2);
  let downTotal = (progress.payload.total/(1024*1024)).toFixed(2);
  document.getElementById("download_name").textContent = "Downloading "+progress.payload.download_name;
  document.getElementById("download_progress").textContent = downProgress + "MB / "+downTotal+"MB";
  document.getElementById("launchGame").disabled = true;
  downBar.style.width = `${(progress.payload.downloaded / progress.payload.total) * 100}%`;
  document.querySelector(".progress").style.visibility = "visible";
});

const download_finished = listen("download_finished", (event) => {
  document.getElementById("download_name").textContent = "";
  document.getElementById("download_progress").textContent = "";
  document.getElementById("launchGame").disabled = false;
  document.getElementById("launchGame").textContent ="Launch Minecraft";
  downBar.style.width = 0;
  document.querySelector(".progress").style.visibility = "hidden";
});

window.addEventListener("DOMContentLoaded", () => {
  document.getElementById("up").addEventListener("click", up);
  document.getElementById("down").addEventListener("click", down);
  document.getElementById("back").addEventListener("click", back);
  
});

window.onload = async function() {
  refresh();
}

function up(){
  invoke("shift_up", { id: selected_pack }).then(refresh);
}

function down(){
  invoke("shift_down", { id: selected_pack }).then(refresh);
}

function back(){
  invoke("drop_session");
  window.location.href = "index.html";
}

function refresh(){
  invoke("get_modpacks").then(addModpacks);
}

function addModpacks(modpacks) {
  var modpacks_list = document.getElementById("modpacks");
  while (modpacks_list.firstChild) {
    modpacks_list.removeChild(modpacks_list.lastChild);
  }
  for (let i = 0; i < modpacks.length; i++){
    var div = document.createElement("div"); 
    div.textContent = modpacks[i].name;
    div.className = "modpack";
    div.id = modpacks[i].id;
    if(modpacks[i].id == selected_pack){
      div.classList.add("modpack-selected");
    }
    div.addEventListener("click", function() { modpackClick(modpacks[i].id) });
    modpacks_list.appendChild(div);
  }
}

function modpackClick(id){
  var old = selected_pack;
  document.getElementById(id).classList.add("modpack-selected");
  selected_pack = id;
  document.getElementById(old).classList.remove("modpack-selected");
}